import plainGetIn from './structure/plain/getIn';

var getErrorKey = function getErrorKey(name, type) {
  switch (type) {
    case 'Field':
      return name;
    case 'FieldArray':
      return name + '._error';
  }
};

var createHasError = function createHasError(_ref) {
  var getIn = _ref.getIn;

  var hasError = function hasError(field, syncErrors, asyncErrors, submitErrors) {
    var name = getIn(field, 'name');
    var type = getIn(field, 'type');
    if (!syncErrors && !asyncErrors && !submitErrors) {
      return false;
    }
    var errorKey = getErrorKey(name, type);
    var syncError = plainGetIn(syncErrors, errorKey);
    if (syncError && typeof syncError === 'string') {
      return true;
    }
    var asyncError = getIn(asyncErrors, errorKey);
    if (asyncError && typeof asyncError === 'string') {
      return true;
    }
    var submitError = getIn(submitErrors, errorKey);
    if (submitError && typeof submitError === 'string') {
      return true;
    }

    return false;
  };
  return hasError;
};

export default createHasError;